
from Components.Pixmap import Pixmap
from Renderer import Renderer
from enigma import ePixmap
from enigma import eServiceReference, eServiceCenter
from Tools.Directories import fileExists
from Components.config import config

class g16PicRefBig(Renderer):

	def __init__(self):
		Renderer.__init__(self)
		
	GUI_WIDGET = ePixmap

	def connect(self, source):
		Renderer.connect(self, source)
		self.changed((self.CHANGED_DEFAULT,))
		
	def changed(self, what):
		if self.instance:
			pngname = ""
			sname = self.source.text
			if sname is not None and sname != "":
				tmp = self.alternative(sname).split(':', 10)[:10]
				if len(tmp) > 0 and tmp[0] == '4097':
					tmp[0] = '1'
				sname = '_'.join(tmp)
				pngname = self.findPicon(sname)
				if pngname == "" and len(sname) > 11:
 					pngname = self.findPicon(sname[:-10]+"0000_0_0_0")
					if pngname == "":
						for i in ("1","19","16"):
							if i != tmp[2]:
								tmp[2] = i
								sname = '_'.join(tmp)
								pngname = self.findPicon(sname[:-10]+"0000_0_0_0")
								if pngname != "":
									break
			if pngname == "":
				pngname = "/usr/share/enigma2/hd_glass16/frame/picon_big.png"
			self.instance.setPixmapFromFile(pngname)

	def alternative(self, serviceName):
		def alternativeChannels(service):
			tmp = eServiceCenter.getInstance().list(eServiceReference(service))
			return tmp and tmp.getContent("S", True)
		if serviceName.startswith('1:134:'):
			channels = alternativeChannels(serviceName)
			if channels:
				return channels[0]
		return serviceName

	def findPicon(self, serviceName):
		try:
			pngname = "%s/picon-t/%s.png" % (config.plugins.setupGlass16.par39.value, serviceName)
			if fileExists(pngname):
				return pngname
		except: pass
		return ""

	def postWidgetCreate(self, instance):
		self.changed((self.CHANGED_DEFAULT,))
		
