# -*- coding: utf-8 -*-
from Screens.Screen import Screen
from Components.config import config, configfile
from Components.ActionMap import ActionMap
from Components.Label import Label
from Components.Pixmap import Pixmap
import gettext
from urllib2 import Request, urlopen, URLError, HTTPError
from urllib import quote, urlencode
import random
from xml.dom.minidom import parseString
import codecs
from datetime import datetime
import math
import os
import time
from Plugins.Extensions.setupGlass16.weather import PLUGINPATH, ColorLabel, ENA_W, ENA_C, convToC 
from Screens.InputBox import InputBox
from Components.Input import Input
from Components.Sources.List import List
from socket import socket, AF_INET, SOCK_STREAM
from Plugins.Extensions.setupGlass16.txt import EWEA
from enigma import eTimer

DEFAULT_V = "----"
try:
	E_weather_language = []
	E_weather_language = config.osd.language.value.split("_")
	if os.path.exists(PLUGINPATH + "locale/%s" % (E_weather_language[0])):
		_ = gettext.Catalog('eWeather', PLUGINPATH + 'locale', E_weather_language).gettext
except: pass
NO_WEATHER_PICON = "/usr/share/enigma2/hd_glass16/icons/3200.png"
try:
	path = "2"
	if not config.plugins.setupGlass16.par72.value in (5,6,7):
		path = str(config.plugins.setupGlass16.par72.value)
	path = config.plugins.setupGlass16.par39.value + "/piconWeatherNN/" + path + "/3200.png"
	WEATHER_B = path.replace("3200.png","")
	if os.path.isfile(path):
		NO_WEATHER_PICON = path
except: pass	
ASTRO = ("sun","moon","mercury","venus","mars","jupiter","saturn","uranus","neptune","pluto")
FORECAST = ("obsdate", "daycode", "sunrise", "sunset", "txtshort", "weathericon","hightemperature","lowtemperature","windspeed","winddirection","maxuv")
DAY_NIGHT = _("Forecast for")+" "
EW_FILE = "/tmp/eWeather"
ENA_ASTRO = True
try:
	if not config.plugins.setupGlass16.par101.value:
		ENA_ASTRO = False
except: pass

def Code_utf8(what):
	what = what.replace('\xc2\x86', '').replace('\xc2\x87', '').decode("utf-8", "ignore").encode("utf-8") or ""
	return codecs.decode(what, 'UTF-8')
			
class mainmenu(Screen):

	def __init__(self, session):
		Eskin = """<screen position="0,0" size="1280,720" title="Enhanced Weather" backgroundColor="black" flags="wfNoBorder" >
			<widget name="init_txt" position="40,0" size="1200,720" zPosition="9" font="Prive4;50" valign="center" halign="center" foregroundColor="white" backgroundColor="black" transparent="0" />
			<widget name="Lnow1" font="Prive3;19" position="50,30" zPosition="2" size="150,200" valign="top" halign="right" foregroundColor="yellow" backgroundColor="black" transparent="1" />
			<widget name="now1" font="Prive3;19" position="210,30" zPosition="3" size="210,200" valign="top" halign="left" backgroundColor="black" transparent="1" />
			<widget name="Lnow2" font="Prive3;19" position="400,30" zPosition="2" size="150,200" valign="top" halign="right" foregroundColor="yellow" backgroundColor="black" transparent="1" />
			<widget name="now2" font="Prive3;19" position="560,30" zPosition="3" size="210,200" valign="top" halign="left" backgroundColor="black" transparent="1" />
			<widget name="weathertext" font="Regular;17" position="700,30" zPosition="3" size="122,60" valign="top" halign="center" foregroundColor="#00d100" backgroundColor="black" transparent="1" />
			<widget name="weathericon" position="725,95" size="72,72" zPosition="0" alphatest="blend" />
			<widget name="sunrise0" font="Regular;18" position="835,75" zPosition="1" size="76,20" valign="top" halign="center" foregroundColor="#ffcc00" backgroundColor="black" transparent="1" />		
			<widget name="sunset0" font="Regular;18" position="913,75" zPosition="1" size="76,20" valign="top" halign="center" foregroundColor="#ff3300" backgroundColor="black" transparent="1" />		
			<widget name="temperature" font="Regular;48" position="835,100" zPosition="2" size="155,80" valign="center" halign="center" foregroundColor="yellow" backgroundColor="black" transparent="1" />
			<ePixmap position="1015,30" size="25,25" pixmap="/usr/share/enigma2/hd_glass16/buttons/green25.png" zPosition="2" alphatest="blend" />
			<ePixmap position="1015,86" size="25,25" pixmap="/usr/share/enigma2/hd_glass16/buttons/blue25.png" zPosition="2" alphatest="blend" />
			<widget name="key_green" position="1050,30" zPosition="3" size="190,40" valign="top" halign="left" font="Regular;17" transparent="1" backgroundColor="#353e575e" shadowColor="#1A58A6" shadowOffset="-1,-1" />
			<widget name="key_blue" position="1050,86" zPosition="3" size="190,40" valign="top" halign="left" font="Regular;17" transparent="1" backgroundColor="#353e575e" shadowColor="#1A58A6" shadowOffset="-1,-1" />
			<eLabel position="46,193" size="1188,1" zPosition="8" backgroundColor="#006cbcf0" />"""
		Eskin += '<ePixmap position="835,30" zPosition="0" size="155,40" pixmap="'+PLUGINPATH+'pict/setrise.png" alphatest="blend" />\n'
		offset = 46
		for i in range(0,9):
			a = offset+i*132
			if i != 0:
				Eskin += '<eLabel position="'+str(1+a)+',205" size="1,'+({False:'490', True:'385'}[ENA_ASTRO])+'" zPosition="8" backgroundColor="#006cbcf0" />\n'
			Eskin += '<ePixmap position="'+str(a)+',445" zPosition="0" size="132,'+({False:'254', True:'126'}[ENA_ASTRO])+'" pixmap="'+PLUGINPATH+'pict/ewea'+({False:'3', True:'2'}[ENA_ASTRO])+'.png" alphatest="blend" />\n'
			for x in FORECAST:
				if x == "daycode":
					Eskin += '<widget name="daycode_'+str(i)+'" font="Regular;17" position="'+str(a)+',200" zPosition="5" size="132,20" valign="top" halign="center" foregroundColor="#3399FF" backgroundColor="black" transparent="1" />\n'			
				elif x == "obsdate":
					Eskin += '<widget name="obsdate_'+str(i)+'" font="Regular;17" position="'+str(a)+',222" zPosition="6" size="132,20" valign="top" halign="center" foregroundColor="#3399FF" backgroundColor="black" transparent="1" />\n'			
				elif x == "weathericon":
					Eskin += '<widget name="weathericon_'+str(i)+'" position="'+str(30+a)+',244" zPosition="0" size="72,72" alphatest="blend" />\n'
					if not ENA_ASTRO:
						Eskin += '<widget name="wDir_'+str(i)+'" position="'+str(34+a)+',620" zPosition="1" size="64,64" alphatest="blend" />\n'
				elif x == "txtshort":
					Eskin += '<widget name="txtshort_'+str(i)+'" font="Regular;17" position="'+str(5+a)+',321" zPosition="1" size="122,80" valign="top" halign="center" foregroundColor="#00d100" backgroundColor="black" transparent="1" />\n'			
				elif x == "hightemperature":
					Eskin += '<widget name="hightemperature_'+str(i)+'" font="Regular;21" position="'+str(66+a)+',410" zPosition="3" size="66,25" valign="center" halign="center" foregroundColor="#cc3300" backgroundColor="black" transparent="1" />\n'			
				elif x == "lowtemperature":
					Eskin += '<widget name="lowtemperature_'+str(i)+'" font="Regular;21" position="'+str(a)+',410" zPosition="3" size="66,25" valign="center" halign="center" foregroundColor="#00d100" backgroundColor="black" transparent="1" />\n'			
				elif x == "windspeed":
					Eskin += '<widget name="windspeed_'+str(i)+'" font="Regular;18" position="'+str(20+a)+',469" zPosition="1" size="112,20" valign="top" halign="center" foregroundColor="#26cfc0" backgroundColor="black" transparent="1" />\n'			
				elif x == "maxuv":
					Eskin += '<widget name="maxuv_'+str(i)+'" font="Regular;18" position="'+str(57+a)+',509" zPosition="1" size="75,20" valign="top" halign="center" foregroundColor="#cc00c0" backgroundColor="black" transparent="1" />\n'			
				elif x == "sunrise":
					Eskin += '<widget name="sunrise_'+str(i)+'" font="Regular;18" position="'+str(a)+',575" zPosition="1" size="66,20" valign="top" halign="center" foregroundColor="#ffcc00" backgroundColor="black" transparent="1" />\n'			
				elif x == "sunset":
					Eskin += '<widget name="sunset_'+str(i)+'" font="Regular;18" position="'+str(66+a)+',575" zPosition="1" size="66,20" valign="top" halign="center" foregroundColor="#ff3300" backgroundColor="black" transparent="1" />\n'			
		if ENA_ASTRO:
			Eskin += """<eLabel position="46,603" size="1188,1" zPosition="8" backgroundColor="#006cbcf0" />"""
			a = -1
			for x in ASTRO:
				a += 1
				i = offset+a*118
				Eskin += '<widget name="L_'+x+'" font="Regular;18" position="'+str(i)+',615" zPosition="1" size="118,20" valign="top" halign="center" foregroundColor="#ff9c00" backgroundColor="black" transparent="1" />\n'
				Eskin += '<ePixmap position="'+str(i)+',645" zPosition="0" size="40,40" pixmap="'+PLUGINPATH+'pict/'+x+'.png" alphatest="blend" />\n'
				Eskin += '<widget name="'+x+'" font="Regular;18" position="'+str(18+i)+',640" zPosition="1" size="100,50" valign="center" halign="center" foregroundColor="yellow" backgroundColor="black" transparent="1" />\n'
		Eskin += """</screen>""" 
		self.skin = Eskin
		Screen.__init__(self, session)
		self.now = ("time","city","state","lat","lon","pressure","temperature","realfeel","humidity","weathertext","weathericon","windspeed","winddirection","visibility","precip","uvindex")
		self.Wunits = {"temp":"", "dist":"", "speed":"", "pres":"", "prec":""}
		self["key_green"] = Label(_("Select City"))
		self["key_blue"] = Label(DAY_NIGHT+_("Nighttime"))                                   
		self.dayNight = 0
		self.units = self.chckUnit()
		self.dom = None
		self["weathericon"] = Pixmap()
		self["temperature"] = ColorLabel("--")
		self["weathertext"] = Label(DEFAULT_V)
		self["init_txt"] = Label(EWEA)
		self["now1"] = Label(DEFAULT_V)
		self["now2"] = Label(DEFAULT_V)
		self["sunrise0"] = Label(DEFAULT_V)
		self["sunset0"] = Label(DEFAULT_V)
		self["Lnow1"] = Label(_("Updated at")+":\n"+_("Pressure")+":\n"+_("Latitude")+":\n"+_("Longtitude")+":\n"+_("City")+":\n"+_("Location")+":")
		self["Lnow2"] = Label(_("Realfeel")+":\n"+_("Humidity")+":\n"+_("Wind")+":\n"+_("Visibility")+":\n"+_("Precip")+":\n"+_("Uvindex")+":")		
		self.location = "cEUR|SK|LO001|BANSKA BYSTRICA|"	
		self.remainingTime = int(config.plugins.setupGlass16.par87.value)
		a = config.plugins.setupGlass16.par98.value
		if "|" in a:
			if len(a.split("|")) == 5:
				self.location = a
		for x in ASTRO:
			self[x] = Label(DEFAULT_V)
			self["L_"+x] = Label(_(x))
		for i in range(0,9):
			for x in FORECAST:
				if x == "weathericon":
					self["%s_%s" % (x,i)] = Pixmap()
					if not ENA_ASTRO:
						self["wDir_%s" % i] = Pixmap()
				elif x in ("hightemperature","lowtemperature"):
					self["%s_%s" % (x,i)] = ColorLabel(DEFAULT_V)
				elif not x in ("winddirection"):
					self["%s_%s" % (x,i)] = Label(DEFAULT_V)
		self.waitTimer = eTimer()
		try:
			self.waitTimer_conn = self.waitTimer.timeout.connect(self.letsgo)
		except AttributeError:
			self.waitTimer.timeout.get().append(self.letsgo)
		self["actions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"green": self.greenKey,
			"ok": self.exit,
			"yellow": self.exit,
			"blue": self.blueKey,
			"red": self.exit,
			"cancel": self.exit
		}, -2)
		self.onLayoutFinish.append(self.startWait)

	def chckUnit(self):
		a = config.plugins.setupGlass16.par151.value
		return ({False: a, True:config.plugins.setupGlass16.par98.value[0]}[a == "0"])
		
	def startWait(self):
		self.waitTimer.start(2000)

	def blueKey(self):
		if self.dayNight == 0:
			self.dayNight = 1
			self["key_blue"].setText(DAY_NIGHT+_("Daytime"))
		else:
			self.dayNight = 0
			self["key_blue"].setText(DAY_NIGHT+_("Nighttime"))
		self.letsgo()

	def letsgo(self):
		def fixZero(val):
			if val[0] == "0" and len(val) == 2:
				val = val[1:]
			return val
		def fixTxt(val):
			val = (val.replace(";",",")).lower()
			if "," in val:
				val = val.split(",")
				ret = ""
				for x in range(0, len(val)):
					ret += _(" ".join(val[x].strip().split())) + "," + " "
				return ret[:-2]
			return _(val)
		def showWicon(val,what=""):
			val = fixZero(val)
			pix = WEATHER_B + val + ".png"
			if not os.path.isfile(pix):
				pix = NO_WEATHER_PICON
			try:
				self["weathericon"+what].instance.setPixmapFromFile(pix)
			except: pass
			return True
		def fixDate(d):
			a = d.split("/")
			if len(a) == 3:
				d = "%s. %s. %s" % (fixZero(a[1]),fixZero(a[0]),a[2])
			return d	
		def fixTemp(t):
			tt = ""
			if t[0] != '-' and t[0] != '0':
				tt = '+'
			tt += t
			return tt
		def setColor(x, temp, c):
			if self.units == "f":
				temp = convToC(temp)
				a = convToC(config.plugins.setupGlass16.par149.value)
				b = convToC(config.plugins.setupGlass16.par150.value)
			else:
				a = config.plugins.setupGlass16.par96.value
				b = config.plugins.setupGlass16.par97.value
			if c == 9999:			
				if config.plugins.setupGlass16.par95.value != "None" and temp < a:
					self[x].colorF()
				else:
					self[x].colorW()
			elif c == -9999:			
				if config.plugins.setupGlass16.par95.value != "None" and temp > b:
					self[x].colorF()
				else:
					self[x].colorC()
			elif temp < -10:			
				self[x].color0()
			elif temp < -5:			
				self[x].color1()
			elif temp < 5:			
				self[x].color2()
			elif temp >= 40:
				self[x].color10()
			elif temp >= 35:
				self[x].color9()
			elif temp >= 30:
				self[x].color8()
			elif temp >= 25:
				self[x].color7()
			elif temp >= 20:
				self[x].color6()
			elif temp >= 15:
				self[x].color5()
			elif temp >= 10:
				self[x].color4()
			elif temp >= 5:
				self[x].color3()
		def netChck():
			try:
				chck = socket(AF_INET, SOCK_STREAM)
				chck.settimeout(0.8)
				return not bool(chck.connect_ex(('www.accuweather.com', 80)))
			except: pass
			return False
		def download_xml():
			os.system("rm -rf %s" % EW_FILE)
			data = er = None
			if netChck():
				self.units = self.chckUnit()
				location = ({False: self.location, True:self.location[1:]}[self.location[0] in ("c","f")])
				req = Request("http://forecastfox.accuweather.com/adcbin/forecastfox/weather_data.asp?&partner=forecastfox&par=" + str(random.randrange(1000)) + "&location=" + quote(location) + "&metric=" + self.units.replace("f","0").replace("c","1"))
				try:
					response = urlopen(req, timeout = 5)
				except HTTPError as e:
					er = 'Error' + ": " + str(e)
				except URLError as e:
					er = 'Error' + ": " + str(e)
				else:
					data = response.read()
					response.close()								
				if data is not None:
					f = open(EW_FILE, 'a')
					f.write("Hello")
					f.close()
					config.plugins.setupGlass16.par99.value = data
			return data						
		self.waitTimer.stop()
		tt = {}
		iconsFix = {"01":"32","02":"34","03":"30","04":"30","05":"34","06":"28","07":"26","08":"26","11":"22","12":"11",
								"13":"39","14":"39","15":"35","16":"37","17":"38","18":"12","19":"5","20":"6","21":"7","22":"16",
								"23":"13","24":"25","25":"5","26":"10","29":"5","30":"36","31":"25","32":"23","33":"31","34":"33",
								"35":"33","36":"27","37":"29","38":"27","39":"45","40":"40","41":"47","42":"47","43":"46","44":"46"}
		if self.dom is None:
			data = None
			try:
				lt = int(config.plugins.setupGlass16.par87.value)
				self.remainingTime = lt
				aa = config.plugins.setupGlass16.par152.value
				if config.plugins.setupGlass16.par100.value != self.location:
					config.plugins.setupGlass16.par100.value = self.location 
					data = download_xml()
				elif aa[1] != config.plugins.setupGlass16.par151.value: 
					config.plugins.setupGlass16.par152.value = aa[0] + config.plugins.setupGlass16.par151.value
					data = download_xml()
				elif os.path.isfile(EW_FILE):
					fileTime = int((time.time() - os.stat(EW_FILE).st_mtime)/60)
					if fileTime >= lt:
						data = download_xml()
					else:
						self.remainingTime = lt - fileTime
						data = config.plugins.setupGlass16.par99.value 
				else:
					data = download_xml()		
			except: return
			if data is not None:
				self.dom = parseString(Code_utf8(data))
			for x in self.Wunits.keys():
				try:
					self.Wunits[x] = str(self.dom.getElementsByTagName(x)[0].firstChild.nodeValue)
				except: pass		
			for x in self.now:
				tt[x] = DEFAULT_V
				try:
					e = str(self.dom.getElementsByTagName(x)[0].firstChild.nodeValue)
					if x == "pressure":
						tt[x] = _(str(self.dom.getElementsByTagName(x)[0].getAttribute("state")))+", "
						if self.Wunits["pres"] == "mb":
							self.Wunits["pres"] = "hPa"
							e = str(int(e)*10)
					elif x == "uvindex":
						tt[x] = str(self.dom.getElementsByTagName(x)[0].getAttribute("index"))+" "
						e = _(e)
					tt[x] = ({False: tt[x]+e, True:e}[tt[x] == DEFAULT_V])
				except: pass                
			if ENA_ASTRO:
				for x in ASTRO:
					try:
						self[x].setText("%s\n%s" % (str(self.dom.getElementsByTagName("planets")[0].getElementsByTagName(x)[0].getAttribute("rise")),str(self.dom.getElementsByTagName("planets")[0].getElementsByTagName(x)[0].getAttribute("set"))))
					except: pass 	
			a = showWicon(iconsFix.get(tt["weathericon"],"3200"))
			try:
				a = tt["temperature"]
				self["temperature"].setText(fixTemp(a)+unichr(176).encode("latin-1")+self.Wunits["temp"])
				setColor("temperature", int(a), ENA_W)
				self["weathertext"].setText(fixTxt(tt["weathertext"]))
				self["now1"].setText(fixZero(tt["time"])+"\n"+tt["pressure"]+self.Wunits["pres"]+"\n"+tt["lat"]+"\n"+tt["lon"]+"\n"+tt["city"]+"\n"+" ".join(tt["state"].strip().split()))
				self["now2"].setText(tt["realfeel"]+unichr(176).encode("latin-1")+self.Wunits["temp"]+"\n"+tt["humidity"]+"\n"+tt["windspeed"]+self.Wunits["speed"]+", "+_(tt["winddirection"])+"\n"+tt["visibility"]+self.Wunits["dist"]+"\n"+tt["precip"]+self.Wunits["prec"]+"\n"+tt["uvindex"]) 
			except: pass
		ttf = {}
		for i in range(0,9):
			for x in FORECAST:
				ttf["%s_%s" % (x,i)] = DEFAULT_V
				try:
					ttf["%s_%s" % (x,i)] = str(self.dom.getElementsByTagName("day")[i].getElementsByTagName(x)[({False: self.dayNight, True:0}[self.dayNight == 1 and x in ("obsdate", "daycode", "sunrise", "sunset")])].firstChild.nodeValue)
				except: pass
		for x in ttf.keys():         
			try:
				if "maxuv" in x:
					self[x].setText("max "+ttf[x])
				elif "obsdate" in x:
					self[x].setText(fixDate(ttf[x]))
				elif "hightemperature" in x or "lowtemperature" in x:
					a = ttf[x]
					self[x].setText(fixTemp(a)+unichr(176).encode("latin-1")+self.Wunits["temp"])
					if "hightemperature" in x:
						setColor(x, int(a), ENA_W)
					else:
						setColor(x, int(a), ENA_C)
				elif "windspeed" in x:
					a = ttf[x.replace("windspeed","winddirection")]
					self[x].setText(ttf[x]+self.Wunits["speed"]+", "+_(a))			
					if not ENA_ASTRO:
						self["wDir%s" % x.replace("windspeed","")].instance.setPixmapFromFile(PLUGINPATH+'pict/'+a+'.png')
				elif "weathericon" in x:
					a = showWicon(iconsFix.get(ttf[x],"3200"),x.replace("weathericon",""))   
				elif "txtshort" in x:
					self[x].setText(fixTxt(ttf[x]))
				elif not "winddirection" in x:
					self[x].setText(_(ttf[x]))
			except: pass
		self["sunrise0"].setText(ttf["sunrise_0"])
		self["sunset0"].setText(ttf["sunset_0"])
		del ttf
		del tt
		self["init_txt"].hide()
    		
	def exit(self):        	
		del self.dom						
		self.dom = None		
		self.waitTimer_conn = None
		self.waitTimer = None
		self.close()			

	def greenKey(self):
		self.session.openWithCallback(self.selAnswer, selectCity)

	def selAnswer(self, ret):        
		if ret: 
			if ret != "x" and ret != config.plugins.setupGlass16.par100.value:
				self.location = ret
				config.plugins.setupGlass16.par98.value = ret
				config.plugins.setupGlass16.par98.save()
				configfile.save()
				self.dom = None
				self.letsgo()

class selectCity(Screen):   

	skin = """
	<screen name="selectCity" position="center,center" size="800,500" title="" backgroundColor="#31000000" >
		<widget source="list" render="Listbox" position="10,10" zPosition="1" size="780,440" scrollbarMode="showOnDemand" transparent="1" >
		<convert type="StringList" />
		</widget>
	<widget name="key_red" position="0,460" size="200,40" zPosition="2" valign="center" halign="center" font="Prive3;22" transparent="1" foregroundColor="red" />
	<widget name="key_yellow" position="200,460" size="200,40" zPosition="2" valign="center" halign="center" font="Prive3;22" transparent="1" foregroundColor="yellow" />
	<widget name="key_blue" position="400,460" size="200,40" zPosition="2" valign="center" halign="center" font="Prive3;22" transparent="1" foregroundColor="blue" />
	<widget name="key_green" position="600,460" size="200,40" zPosition="2" valign="center" halign="center" font="Prive3;22" transparent="1" foregroundColor="green" />
	</screen>"""

	def __init__(self,session):
		self.skin = selectCity.skin
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.fileName = "/etc/ewea_city_Code.txt"
		self["key_green"] = Label(_("Select City"))
		self["key_yellow"] = Label(_("Add City"))
		self["key_red"] = Label(_("Delete City"))
		self["key_blue"] = Label(_("Change Temperature Unit"))
		if config.plugins.setupGlass16.par151.value != "0":
			self["key_blue"].hide()
		self['list'] = List(self.list)	
		self["actions"] = ActionMap(['WizardActions', 'ColorActions'],
		{
			"green": self.select,
			"ok": self.select,
			"yellow": self.yellowKey,
			"red": self.redKey,
			"blue": self.blueKey,
			"back": self.exit
		})    
		self.onLayoutFinish.append(self.mainFnc)

	def exit(self): 
		self.close('x')
		
	def setWindowTitle(self):
		self.setTitle(_("Select City"))
		
	def select(self):
		selection = self['list'].getCurrent()
		if selection:
			self.close(str(selection[1]))
		self.exit()
		
	def mainFnc(self,w="",d=False):
		self.setWindowTitle()
		self.list = []
		c = 0
		allLines = ""
		try:
			f = open(self.fileName,"r")
			for i in f.readlines():
				value = None
				if "|" in i and "-" in i:
					tmp = (i.replace("\n","")).strip().split("-")
					if len(tmp[1].split("|")) == 5:
						if len(tmp) == 2:
							value = "c"+tmp[1]  
						elif len(tmp) == 3 and tmp[2].lower() in ["c","f"]:
							value = tmp[2].lower()+tmp[1]							
				if value:
					c += 1
					cc = w != "" and w == value
					if not d or (d and not cc):
						if cc:
							value = ({False: "c", True:"f"}[w[0] == "c"])+value[1:]					
						allLines += ({False: i, True:tmp[0].encode("utf-8")+"-"+value[1:]+"-"+value[0]+"\n"}[cc])
						self.list.append((str(c)+".    "+({False: "", True:unichr(176).encode("latin-1") + value[0].upper()}[config.plugins.setupGlass16.par151.value == "0"])+"     " + tmp[0].encode("utf-8"),value))    
			f.close()
			if w != "" and len(self.list) != 0:
				f = open(self.fileName,"w")
				f.write(allLines)
				f.close()
		except: pass
		if len(self.list) == 0:
			self.list = [(_('None city founded'), 'x')]
		self['list'].list = self.list
  		
	def blueKey(self):
		if config.plugins.setupGlass16.par151.value == "0":
			selection = self['list'].getCurrent()
			if selection and selection[1] != "x":
				self.mainFnc(selection[1])

	def redKey(self):
		selection = self['list'].getCurrent()
		if selection and selection[1] != "x":
			self.mainFnc(selection[1],True)
		
	def yellowKey(self):
		self.session.openWithCallback(self.changeCityAnswer, InputBox, title=_("Please enter a city name")+": ", text="banska bystrica                   ", maxSize=50, type=Input.TEXT)

	def changeCityAnswer(self, name):
		if name is None and name != "":
			return		
		self.session.openWithCallback(self.callbackNewCity, addSelectCity, name)

	def callbackNewCity(self, ret):
		if ret != "x":
			try:
				f = open(self.fileName,"a")
				f.write(ret+"\n")		
				f.close()
			except: pass				
			self.mainFnc()				
				
class addSelectCity(Screen):
	skin = """<screen position="center,center" size="500,300" title="Select city">
		<widget source="list" render="Listbox" position="10,10" zPosition="1" size="480,280" scrollbarMode="showOnDemand" transparent="1" >
		<convert type="StringList" />
		</widget>
		</screen>"""

	def __init__(self, session, name):
		Screen.__init__(self, session)
		self.name = name
		self.list = [(_('None city founded'), 'x')]
		self['list'] = List(self.list)
		self['actions'] = ActionMap(['WizardActions', 'ColorActions'], {'back': self.exit,'ok': self.retSel})
		self.onLayoutFinish.append(self.initList)					

	def exit(self): 
		self.close('x')

	def initList(self):
		self.setTitle(_("Select City"))
		req = Request('http://forecastfox.accuweather.com/adcbin/forecastfox/locate_city.asp?partner=forecastfox&location=' + quote(self.name))
		data = er = None
		try:
			response = urlopen(req, timeout = 5)
		except HTTPError as e:
			er = 'Error' + ": " + str(e)
		except URLError as e:
			er = 'Error' + ": " + str(e)
		else:
			data = response.read()
			response.close()
		if data is not None:
			c = []
			dom = ""
			try:
				dom = parseString(Code_utf8(data))
				for x in range(0, int(str(dom.getElementsByTagName("citylist")[0].getAttribute("extra_cities"))) + int(str(dom.getElementsByTagName("citylist")[0].getAttribute("us"))) + int(str(dom.getElementsByTagName("citylist")[0].getAttribute("intl")))):
					a = str(dom.getElementsByTagName("location")[x].getAttribute("location"))
					if "|" in a:
						if len(a.split("|")) == 5:
							tt = str(dom.getElementsByTagName("location")[x].getAttribute("city"))
							c.append((tt + ", " + str(dom.getElementsByTagName("location")[x].getAttribute("state")), tt+"-"+a+"-c"))
			except: pass
			if len(c) != 0:
				self.list = c
			del dom
			del c			
		self['list'].list = self.list  
  
	def retSel(self):  
		del self.list
		selected = self['list'].getCurrent()
		if selected:
			self.close(selected[1])
		else: 
			self.close('x')
