# -*- coding: utf-8 -*-
from Components.config import config, ConfigSubsection, ConfigYesNo 
import gettext
import os
PLUGINPATH = "/usr/lib/enigma2/python/Plugins/Extensions/setupGlass16/"
config.plugins.setupGlass16 = ConfigSubsection()
config.plugins.setupGlass16.par49 = ConfigYesNo(default = True) # enable translation
try:
	if config.plugins.setupGlass16.par49.value:
		g16_language = []
		g16_language = config.osd.language.value.split("_")
		if os.path.exists(PLUGINPATH + "locale/%s" % (g16_language[0])):
			_ = gettext.Catalog('helpTxt', PLUGINPATH + 'locale', g16_language).gettext
except: pass

NO_TP = _('TP info is not detected')
NO_REF = _('Reference is not detected')
E_EPG = _('No EPG data available')
EWEA = _('Please wait for the reading and processing of data')+' .....'
helpTxt = {
'144-0' : _('Directory where will be saved actual configuration of HDG (file: hdg16.conf)'),
'143-0' : _('Connection to the website of selected provider without using SSL unverified content'),
'143-1' : _('Connection to the website of selected provider with using SSL unverified content'),
'101-1' : _('Appears info about sunrise, sunset of planets, sun and moon'),
'00' : _('Sorry, help info is missing'),
'1-0' : _('Info is displayed with defined color'),
'1-1' : _('Info is displayed with autoselected color'),
'5-1' : _('Show extra screen only'),
'10-0' : _('None special info is selected'),
'12-0' : _('Show extra infobar only'),
'12-1' : _('Show side bar and extra infobar only'),
'13-0' : _('1 - fastest, 10 - slowest'),
'14-0' : _('Infobar appears immediately and disapears immediately'),
'14-1' : _('Infobar (dis)appears from full/defined transparency to defined(full) transparency'),
'15-0' : _('Infobar appears immediately and disapears from defined to full transparency'),
'15-1' : _('Infobar (dis)appears from full/defined transparency to defined(full) transparency'),
'17-0' : _('Show extra infobar only'),
'17-1' : _('Show extra infobar and press 2xOK show User info'),
'18-7' : _('Show extra infobar only'),
'19-0' : _('Apears user info press 2x"OK" and disappears with extra infobar'),
'19-1' : _('Apears user info press 2x"OK" and disappears press "OK" or "exit"'),
'20-0' : _('Show actual event(EPG) only'),
'20-1' : _('Press long ">" switch between actual and next evet(EPG)'),
'21-0' : _('Show extra infobar only'),
'21-1' : _('Display ECM PID info with extra infobar'),
'23-0' : _('Show events name in infobar as static text'),
'23-1' : _('Show events name in infobar char by char with typewritter effect'),
'25-0' : _('Show OLED design from "image" definition'),
'27-0' : _('Display "Btr too high - stopped" if realtime bitrate is higher as the set value'),
'29-0' : _('Use only if in your image is keymapping set to "standard Enigma2"'),
'29-1' : _('Use only if in your image is keymapping set to "Neutrino keymap type"'),
'35-0' : _('Show messages in default language - english'),
'35-1' : _('Show localized messages autodetected from active OSD setting of language'), 
'39-0' : _('Infobar disappears after a defined timeout in system settings'), 
'39-1' : _('Infobar activated by switching between channels disappears after a defined timeout in system settings. Infobar activated press "OK" appears permanently but can be cancelled press "exit" or "OK"'),
'39-2' : _('Infobar activated press "OK" appears permanently but disappears press "exit" or "OK"'),
'41-3' : _('Check connection to the point in internet defined by IP adress'),
'1007-70' : _('Wake up HDD is managing by image only'),
'1007-71' : _('Wake up HDD if any function cannot read requested info if HDD is sleeping'),
'104-0' : _('auto - autodetection of tuners presented in box; value (1-16) - display selected numbers of tuners'),
'105-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'106-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'107-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'108-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'112-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'113-0' : _('Autocolor - use definition from skin.xml or g16Screens.py; selected color - display with selected color'),
'114-0' : _('Do not display flashing icon "R" in infobar'),
'114-1' : _('Display flashing icon "R" in infobar'),
'42-0' : _('Leave memory management untouched'),
'420-0' : _('Detecting AC3/Dolby in all available audio tracks'),
'420-1' : _('Detecting AC3/Dolby, Dolby Digital 5.1/2.0, DTS, AAC, Mpeg in current audio track'),
'42-1' : _('Automatic memory cleaning - refresh time: 3min'),
'42-2' : _('IP Address used for network status check - available connection to the Internet'),
'43-0' : _('Used to encoding.conf origin from active image'),
'43-1' : _('Used to encoding-user.conf located in /usr/share/enigma2'),
'45-0' : _('Channel selection works with standard functionality'),
'45-1' : _('Press "OK" - activate selected channel and channel selection no appear then press "OK" - disappear channel selection or press "exit" revert on last playd channel before activating Channel selection'),
'46-0' : _('Press "OK" to start selected item without animation'),
'46-1' : _('Press "OK" to start animation before activating selected item'),
'48-0' : _('Error messages generated by tuner are enabled'),
'48-1' : _('Error messages generated by tuner are disabled'),
'500-0' : _('Display services list without satellite picon'),
'500-1' : _('Display services list with satellite picon'),
'500-2' : _('Display services list with satellite picon only'),
'52-0' : _('Show Weather for selected city in the setup'),
'52-1' : _('Press ">" show Weather for next city'),
'53-0' : _('Special info screen (activated press "help") disappear press "help"'),
'53-1' : _('Special info screen (activated press "help") disappear automatically after 20s'),
'54-0' : _('Refresh time for reading ecm.info file'),
'55-0' : _('Disable autocheck of new version of the HDG'),
'55-1' : _('Enable autocheck of new version of the HDG'),
'56-0' : _('Static text - no scrolling'),
'56-1' : _('Roll up at end of text and stop wait selected seconds (text roll delay) then roll down back'),
'56-2' : _('Roll up at end of text and stop'),
'57-0' : _('Text rolling starts with delay defined in skin.xml'),
'57-1' : _('Text rolling starts with selected delay (s)'),
'58-0' : _('None special info is selected'),
'58-1' : _('Transporder and ECM info'),
'58-2' : _('ECM info coded by duri'),
'58-3' : _('Weather light version'),
'59-0' : _('Show channel name only'),
'59-1' : _('Show number and channel name'),
'59-2' : _('Show satellite position and channel name'),
'59-3' : _('Show number, satellite position and channel name'),
'60-0' : _('None info about "Provider" in infobar'),
'60-1' : _('Show info about "Provider" in infobar'),
'61-0' : _('None info about "Temperature and RPM" in infobar'),
'61-1' : _('Show info about "Temperature and RPM" in infobar'),
'62-0' : _('None info about "CPU usage and Memory usage" in infobar'),
'62-1' : _('Show info about "CPU usage and Memory usage" in infobar'),
'63-0' : _('None info about "Temperature HDD" in infobar'),
'63-1' : _('Show info about "Temperature HDD" in infobar'),
'64-0' : _('Do not display selected special info "extensions" in main menu'),
'64-1' : _('Display selected special info "extensions" in main menu'),
'65-0' : _('Temperature will be displayed with units defined in my_city_Code.txt or city_Code.txt'),
'151-0' : _('Temperature will be displayed with units defined in eWea_city_Code.txt'),
'65-c' : _('Temperature will be displayed in Celsius'),
'65-f' : _('Temperature will be displayed in Fahrenheit'),
'66-0' : _('Reconnect time for reading weather data from website in minutes'),
'67-0' : _('Reading weather data from Yahoo rss channel'),
'67-1' : _('Reading weather data from MSN website'),
'90-0' : _('"Find a city" is disabled'),
'90-1' : _('"Find a city" is disabled in extensions list'),
'90-2' : _('"Find a city" is disabled in main menu'),
'91-0' : _('Do not try get data from provider if an error is detected'),
'91-1' : _('Autoreconnect - try get data from provider if an error is detected - try with cycle in selected time while data are not ok'),
'92-0' : _('Display forecast for today and next 3 days'),
'92-1' : _('Display forecast for yesterday, today and next 3 days'),
'93-0' : _('High temperature appear in Autocolor'),
'93-1' : _('High temperature appear in selected color'),
'94-0' : _('Low temperature appear in Autocolor'),
'94-1' : _('Low temperature appear in selected color'),
'95-0' : _('Cold/warm temperature appears in selected color (Cold/Warm color)'),
'95-1' : _('Cold temperature is higher as settings of "Cold temperature" or/and Warm temperature is lower as "Warm temperature"'),
'96-0' : _('Warm temperature limit range: 15-40')+unichr(176).encode("latin-1")+"C",
'97-0' : _('Cold temperature limit range: 1-14')+unichr(176).encode("latin-1")+"C", 
'149-0' : _('Warm temperature limit range: 58-104')+unichr(176).encode("latin-1")+"F",
'150-0' : _('Cold temperature limit range: 33-57')+unichr(176).encode("latin-1")+"F",
'22-1-0' : _('HDD detected by kernel as device'),
'46-1-0' : _('Searching directory for OLED picon'),
'39-1-0' : _('Path to all required directories like picon, piconProv and more.'),
'124-0' : _('User defined path to all required directories like picon, piconProv and more. Press "OK" or "Green" you can select your favorite directory.'),
'126-0' : _('Channel numbers are calculated at enigma start so any change in channels order have no effect to channel numbers'),
'126-1' : _('Channel number is calculated after switching between channels always so every change in channel order is applied on calculation of channel number'),
'127-0' : _('Date format will be used from definition in skin part')+' ('+_('Used in Infobar and Extra screen')+')',
'127-1' : _('Date format will be used as follow')+' ('+_('Used in Infobar and Extra screen')+')',
'141-1' : _('Extensions are displayed according to the definition Extensions List screen'),
'141-2' : _('Extensions are displayed according to the definition Choice box screen')
}
